--[[	SlashHelp
	by SDPhantom
	http://www.phantomweb.org	]]
------------------------------------------

--	Change this to adjust the size of the command list.
local DisplaySize=32;--	Maximum number of entries to display.

--	Temperary variable to rememeber if the video card supports desaturation.
local CanDesaturate=false;

SlashHelp={
	ScrollOffset=0;
	CommandList={};

--	INTERNAL USE ONLY:	Registers the scroll frame in the XML file for use with the SlashHelp class
	InitScrollFrame=function(self,frame)
--			Setup frame and class pointers
			self.ScrollFrame=frame;
			frame.Top=self;

--			Build the command list
			frame.ButtonList={};
			for i=1,DisplaySize do
				local btn=CreateFrame("Button",nil,frame,"SlashHelpEntryTemplate");

				if i<=1 then
					btn:SetPoint("TOPLEFT",frame,"TOPLEFT",8,-17);
				else
					btn:SetPoint("TOPLEFT",frame.ButtonList[i-1],"BOTTOMLEFT");
				end
--				btn:SetPoint("RIGHT",frame,"RIGHT",-8,0);
				btn:SetPoint("RIGHT",frame,"RIGHT",-10,0);

				btn.CommandText:SetText("Test"..i);
				btn.SectionText:SetText("Test"..i);

				frame.ButtonList[i]=btn;
			end

--			List position/scroll management
			frame:HookScript("OnUpdate",function(self)
				local parent=self:GetParent();
				local sx,sy=UIParent:GetCenter();
				local px,py=parent:GetCenter();

				self:ClearAllPoints();
				self.OptionsFrame:ClearAllPoints();

--				Scroll frame positioning
				self:SetPoint((py<sy and "BOTTOM" or "TOP").."LEFT",parent,(py<sy and "TOP" or "BOTTOM").."LEFT",3,py<sy and -6 or 6);
				self:SetPoint((py<sy and "BOTTOM" or "TOP").."RIGHT",parent,(py<sy and "TOP" or "BOTTOM").."RIGHT",-3,py<sy and -6 or 6);

--				Options frame positioning
				self.OptionsFrame:SetPoint(
					(py<sy and "BOTTOM" or "TOP")..(px<sx and "LEFT" or "RIGHT")
					,self
					,(py<sy and "BOTTOM" or "TOP")..(px<sx and "RIGHT" or "LEFT")
					,px<sx and -3 or 3,0
				);

--				Button scroll
				if self.UpButton:GetButtonState()=="PUSHED" then self.Top:ScrollBy(-1); end
				if self.DownButton:GetButtonState()=="PUSHED" then self.Top:ScrollBy(1); end
			end);

--			Scrollwheel support
			frame:EnableMouseWheel(1);
			frame:HookScript("OnMouseWheel",function(self,delta) self.Top:ScrollBy(-delta*3); end);
		end;

--	INTERNAL USE ONLY:	Comparison function for table.sort()
	SortFunc=function(v1,v2)
			local v1len;
			local v2len;
			local i;

--			Group Sort
			if SlashHelp.ScrollFrame.OptionsFrame.GroupSort:GetChecked() then
				v1len=v1.Section:len();
				v2len=v2.Section:len();
				for i=1,min(v1len,v2len) do
					local v1char=v1.Section:lower():byte(i);
					local v2char=v2.Section:lower():byte(i);
					if v1char~=v2char then
						return v1char<v2char;
					end
				end

				if v1len~=v2len then
					return v1len<v2len;
				end
			end

--			Alphabetical Sort
			v1len=v1.Command:len();
			v2len=v2.Command:len();
			for i=1,min(v1len,v2len) do
				local v1char=v1.Command:lower():byte(i);
				local v2char=v2.Command:lower():byte(i);
				if v1char~=v2char then
					return v1char<v2char;
				end
			end

			return v1len<v2len;
		end;

--	Apply filter
	SetFilter=function(self,filter)
			if not self.CurOwner then return; end
			self.CommandList=table.wipe(self.CommandList);

			if type(filter)=="string" and filter:sub(1,1)=="/" then
--				This isn't defined or used elsewhere, but needs to be permanent for good memory management
				self.NameSpace=table.wipe(self.NameSpace or {});--	Command namespace

				self.ScrollOffset=0;
				self.CurFilter=filter;
				for k,v in pairs(_G) do
					if type(v)=="string" and v:sub(1,1)=="/" then
						local ctype=k:match("^SLASH_(.-)%d+$");
						if not ctype then
							ctype=k:match("^EMOTE(%d+)_CMD%d+$");
						end

						local cmdid=("%s_%s_%s"):format(k:sub(1,5),ctype or "",v);--	Namespace ID (Command type, ID, and slash string)
						if ctype and v:sub(1,filter:len()):lower()==filter:lower() and not self.NameSpace[cmdid] then
							if k:sub(1,5)=="EMOTE" then
								if SlashHelp.ScrollFrame.OptionsFrame.ShowEmote:GetChecked() then
									self.NameSpace[cmdid]=true;
									self.CommandList[(#self.CommandList)+1]={
										Command=v;
										Section=(getglobal("EMOTE"..(tonumber(ctype) or 0).."_TOKEN") or "");
										Color={0.75,0,0.5};
									};
								end
							elseif ChatTypeInfo[ctype] then
								if SlashHelp.ScrollFrame.OptionsFrame.ShowChat:GetChecked() then
									self.NameSpace[cmdid]=true;
									self.CommandList[(#self.CommandList)+1]={
										Command=v;
										Section=ctype;
										Color={0,0.75,0};
									};
								end
							elseif IsSecureCmd(v) then
								if SlashHelp.ScrollFrame.OptionsFrame.ShowSecureCmd:GetChecked() then
									self.NameSpace[cmdid]=true;
									self.CommandList[(#self.CommandList)+1]={
										Command=v;
										Section=ctype;
										Color={0.5,0.5,1};
									};
								end
							elseif SlashCmdList[ctype] then
								if SlashHelp.ScrollFrame.OptionsFrame.ShowNormalCmd:GetChecked() then
									self.NameSpace[cmdid]=true;
									self.CommandList[(#self.CommandList)+1]={
										Command=v;
										Section=ctype;
										Color={0.75,0.5,0};
									};
								end
							end
						end
					end
				end
			end

--			Show/Hide and adjust scroll frame
			local cmdlen=#self.CommandList;
			if cmdlen>0 then
--				Sort and update display
				table.sort(self.CommandList,self.SortFunc);
				self:UpdateList();

--				Adjust scroll frame
				if cmdlen>DisplaySize then
					self.ScrollFrame.UpButton:Show();
					self.ScrollFrame.DownButton:Show();
					self.ScrollFrame:SetHeight(12*(DisplaySize+2)+10);

					self.ScrollFrame.ButtonList[1]:SetPoint("TOPLEFT",self.ScrollFrame,"TOPLEFT",8,-17);
				else
					self.ScrollFrame.UpButton:Hide();
					self.ScrollFrame.DownButton:Hide();
					self.ScrollFrame:SetHeight(12*cmdlen+16);

					self.ScrollFrame.ButtonList[1]:SetPoint("TOPLEFT",self.ScrollFrame,"TOPLEFT",8,-8);
				end

				self.ScrollFrame:Show();
			else
				self.ScrollFrame:Hide();
			end
		end;

--	INTERNAL USE ONLY:	Reapply current filter (Used to apply changes to option settings)
	ReFilter=function(self) self:SetFilter(self.CurFilter); end;

--	INTERNAL USE ONLY:	Redraw display
	UpdateList=function(self)
			local cmdlen=#self.CommandList;
			local scrollremain=math.max(0,cmdlen-DisplaySize);

--			Trim scroll value before using
			self.ScrollOffset=math.max(0,math.min(scrollremain,self.ScrollOffset));

--			Update scroll button state
			if self.ScrollOffset<=0 then
				self.ScrollFrame.UpButton:Disable();

				if CanDesaturate then
					CanDesaturate=(type(self.ScrollFrame.UpButton.Arrow:SetDesaturated(1))~="nil");
				end
				if not CanDesaturate then--	Needs to be out of the last block in case desaturation failed
					self.ScrollFrame.UpButton.Arrow:SetVertexColor(0.5,0.5,0.5);
				end
			else
				self.ScrollFrame.UpButton:Enable();
				if CanDesaturate then
					self.ScrollFrame.UpButton.Arrow:SetDesaturated(0)
				else
					self.ScrollFrame.UpButton.Arrow:SetVertexColor(1,1,1);
				end
			end
			if self.ScrollOffset>=scrollremain then
				self.ScrollFrame.DownButton:Disable();

				if CanDesaturate then
					CanDesaturate=(type(self.ScrollFrame.DownButton.Arrow:SetDesaturated(1))~="nil");
				end
				if not CanDesaturate then--	Needs to be out of the last block in case desaturation failed
					self.ScrollFrame.DownButton.Arrow:SetVertexColor(0.5,0.5,0.5);
				end
			else
				self.ScrollFrame.DownButton:Enable();
				if CanDesaturate then
					self.ScrollFrame.DownButton.Arrow:SetDesaturated(0)
				else
					self.ScrollFrame.DownButton.Arrow:SetVertexColor(1,1,1);
				end
			end

--			Reposition scroll bar (Needs to recalculate scroll frame height, may not be set yet)
			local scrollbar=self.ScrollFrame.ScrollBar;
			local maxbarlen=(cmdlen>DisplaySize and 12*(DisplaySize+2)-2 or 12*cmdlen+4);
			local barlen=math.max(2,math.min(maxbarlen,maxbarlen*DisplaySize/cmdlen));
			scrollbar:ClearAllPoints();
			scrollbar:SetPoint("TOPRIGHT",-5,-((maxbarlen-barlen)*self.ScrollOffset/math.max(1,scrollremain))-6);
			scrollbar:SetHeight(barlen);

--			Update listings
			for i,j in ipairs(self.ScrollFrame.ButtonList) do
				local ptr=self.CommandList[i+self.ScrollOffset];
				if ptr then
					j.CommandText:SetTextColor(unpack(ptr.Color));
					j.CommandText:SetText(ptr.Command);
					j.SectionText:SetText(ptr.Section);
					j:Show();
				else
					j:Hide();
				end
			end
		end;

--	Scroll functions (zero-based, + scrolls down, - scrolls up)
	ScrollTo=function(self,val)--		Scroll to position
			self.ScrollOffset=math.max(0,math.min(#self.CommandList-#self.ScrollFrame.ButtonList,val));
			self:UpdateList();
		end;
	ScrollBy=function(self,offset)--	Scroll by offset
			self.ScrollOffset=math.max(0,math.min(#self.CommandList-#self.ScrollFrame.ButtonList,self.ScrollOffset+offset));
			self:UpdateList();
		end;

--	Owner control functions
	SetOwner=function(self,editframe)--	Sets owner, required to apply filter
			if editframe then
				self.ScrollFrame:SetParent(editframe);
				self.CurOwner=editframe;
				self:SetFilter(editframe:GetText());
			end
		end;
	ClearOwner=function(self,editframe)--	Clears owner and resets list
			if self.CurOwner==editframe then
				self.CurOwner=nil;
				self:SetFilter(nil);
			end
		end;
};

--	API hooks
hooksecurefunc("ChatEdit_OnEditFocusGained",function(self) SlashHelp:SetOwner(self); end);
hooksecurefunc("ChatEdit_OnEditFocusLost",function(self) SlashHelp:ClearOwner(self); end);
hooksecurefunc("ChatEdit_OnTextChanged",function(self) SlashHelp:SetFilter(self:GetText()); end);
hooksecurefunc("ChatEdit_OnTextSet",function(self) SlashHelp:SetFilter(self:GetText()); end);
